package bar.view;

import java.io.File;
import java.io.Serializable;

import org.richfaces.event.UploadEvent;
import org.richfaces.model.UploadItem;

import bar.model.Survey;
import bar.service.SurveyService;
import bar.utils.FileUtils;
import bar.utils.ReadSurveyXMLFormat;

public class FileUploadBean implements Serializable{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private int uploadsAvailable = 1;
	private boolean autoUpload = false;
	private boolean useFlash = false;
	private byte[] data;
	

	public FileUploadBean() {
		System.out.println("[LA] "+this.getClass().getName()+" -> FileUploadBean()");
	}

	public void listener(UploadEvent event){
		System.err.println("JODERRRRR");
		SurveyService ss = new SurveyService();
	    UploadItem item = event.getUploadItem();
	    System.out.println("File : '" + item.getFileName() + "' was uploaded");
	    if (item.isTempFile()) {
	    	System.out.println("[LA] "+this.getClass().getName()+" -> listener(datos en temp)");
		File file = item.getFile();
		data = FileUtils.getBytesFromFile(file);
		Survey survey = ReadSurveyXMLFormat.xmlToBean(data);
	    ss.createSurvey(survey);	
		file.delete();
	    }else {
	    	System.out.println("[LA] "+this.getClass().getName()+" -> listener(datos en RAM)");
	    	try {
	    		data = item.getData();
	    		Survey survey = ReadSurveyXMLFormat.xmlToBean(data);
	    		ss.createSurvey(survey);
			} catch (Exception e) {
				// TODO: handle exception
				e.printStackTrace();
			}
		
	    }
	}

	public long getTimeStamp() {
		System.out.println("[LA] "+this.getClass().getName()+" -> getTimeStamp() -> "+System.currentTimeMillis());
		return System.currentTimeMillis();
	}

	public int getUploadsAvailable() {
		System.out.println("[LA] "+this.getClass().getName()+" -> getUploadsAvailable() -> "+uploadsAvailable);
		return uploadsAvailable;
	}

	public void setUploadsAvailable(int uploadsAvailable) {
		System.out.println("[LA] "+this.getClass().getName()+" -> setUploadsAvailable("+uploadsAvailable+")");
		this.uploadsAvailable = uploadsAvailable;
	}

	public boolean isAutoUpload() {
		System.out.println("[LA] "+this.getClass().getName()+" -> isAutoUpload() -> "+autoUpload);
		return autoUpload;
	}

	public void setAutoUpload(boolean autoUpload) {
		System.out.println("[LA] "+this.getClass().getName()+" -> setAutoUpload("+autoUpload+")");
		this.autoUpload = autoUpload;
	}

	public boolean isUseFlash() {
		System.out.println("[LA] "+this.getClass().getName()+" -> isUseFlash() -> "+useFlash);
		return useFlash;
	}

	public void setUseFlash(boolean useFlash) {
		System.out.println("[LA] "+this.getClass().getName()+" -> setUseFlash("+useFlash+")");
		this.useFlash = useFlash;
	}
	
	public byte[] getData() {
		System.out.println("[LA] "+this.getClass().getName()+" -> getData("+data+")");
		return data;
	}

	public void setData(byte[] data) {
		System.out.println("[LA] "+this.getClass().getName()+" -> setData("+data+")");
		this.data = data;
	}

}
